#version 130              // delete this line if using GLSL 1.2
precision mediump float;  // delete this line if using GLSL 1.2

// uniform shader-parameters
uniform sampler2D colorTexture;
uniform sampler2D depthTexture;
uniform int use_dof;

// fragment-shader input variables
in vec4 frag_color;
in vec2 texture_coordinates;
in vec4 back_color;
in vec4 transp_out;

// fragment-shader output variable (-> stored in the frame-buffer, i.e. "the pixel you see")
out vec4 fragColor;


void main()
{
    if (use_dof == 2) {

	vec4 texel = texture2D(colorTexture, texture_coordinates);

	fragColor = texel;

    } else if (use_dof == 0) {
            vec4 texel = texture2D(colorTexture, texture_coordinates);

            //if (texel.rgb == vec3(0.0, 0.0, 0.0)) {
            if (texel.r < 0.1 && texel.g < 0.1 && texel.b < 0.1) {
                if (back_color.rgb == vec3(0.0, 0.0, 0.0)) {
                 discard;
                } else {
                 fragColor = back_color;
                }
            } else {
                fragColor = texel * frag_color * transp_out;
            }
    } else if (use_dof == 99) {
	fragColor = frag_color;
    } else {
	//vec4 texel = texture2D(colorTexture, texture_coordinates);
	//if (texel.x == 1.0f && texel.y == 1.0f) {
	//	fragColor = vec4(1.0f, 0.0f, 0.0f, 1.0f);
	//} else {
	        vec2 v[13];
        	v[0] = vec2(0.0, 0.0);
	        v[1] = vec2(-0.325216, -0.40581);
	        v[2] = vec2(-0.840144, -0.07358);
        	v[3] = vec2(-0.695914, 0.457137);
	        v[4] = vec2(-0.203345, 0.620716);
	        v[5] = vec2(0.96234, -0.194983);
        	v[6] = vec2(0.473434, -0.480026);
	        v[7] = vec2(0.519456, 0.767022);
	        v[8] = vec2(0.185461, -0.893124);
	        v[9] = vec2(0.507431, 0.064425);
	        v[10] = vec2(0.89642, 0.412458);
	        v[11] = vec2(-0.32194, -0.932515);
	        v[12] = vec2(-0.791559, -0.59771);

	        vec4 depthTexel = texture2D(depthTexture, texture_coordinates);
	        float blurSize = depthTexel.z / 400;

	        vec4 newColor = vec4(0.0, 0.0, 0.0, 1.0);
	        for (int i = 0; i < 13; i++) {
	                float xc = texture_coordinates.x + blurSize * v[i].x;
        	        float yc = texture_coordinates.y + blurSize * v[i].y;

	                vec4 newTexel = texture2D(colorTexture, vec2(xc, yc));
        	        newColor = newColor + newTexel;
	        }
	
        	newColor = newColor / 13;
	        fragColor = newColor;
	//}
    }
}
