
#version 130              // delete this line if using GLSL 1.2
precision mediump float;  // delete this line if using GLSL 1.2

// uniform shader-parameters
uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;
uniform float zeit_v;

// vertex-shader input variables
in vec4 vertex;
in vec4 velocity;

// vertex-shader output variables (passed to fragment-shader)
out vec4 frag_color;

void main()
{
    // just pass color to fragment-shader
    //if (zeit_v >= 5.0f) {
	    //vec4 tmpColor = vec4(0.0f, 0.0f, 0.0f, 1.0f);
	    //tmpColor.x = 1.0f - ((zeit_v - 5.0f) / 1.5f);	
	    //tmpColor.y = 1.0f - ((zeit_v - 5.0f) / 1.5f);
	    //tmpColor.z = 0.0f;
	    //frag_color = tmpColor;
    //} else {
	    frag_color = vec4(0.5f, 0.5f, 0.5f, 0.5f);
    //}

    vec4 newVertexPosition = vec4(vertex.x, vertex.y, vertex.z, 1.0f);
    if (zeit_v >= 5.0f) {
        float tempzeit = zeit_v - 5.0f;
        newVertexPosition.xyz = newVertexPosition.xyz + newVertexPosition.xyz * tempzeit * 5.0f * velocity.xyz;

	vec4 tmpColor = vec4(0.0f, 0.0f, 0.0f, 1.0f);
	tmpColor.x = 1.0f / length(newVertexPosition.xyz);
	tmpColor.y = 0.75f / length(newVertexPosition.xyz);
	frag_color = tmpColor;
    }

    // transform vertex down the pipeline
    gl_Position = perspective * view * model * newVertexPosition;
}
